#<profile4xi profile = "10" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fromfd4xi.py">
#<abstract4xi abstract = "providing function fromfd4xi"/>
#<refer4xi reference = "reduction.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fromfd4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # rare ones
    import socket          
except:
    pass 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fromfd4xi" usage = "
#   older rebuild_socket4xi.py:
#             _socket2xi = fromfd4xi(fd2xi, family, type_, proto)
#   [Rel 7.21] to be explored
#"> 
# -------------------------------------------------------------------------------------------------
def fromfd4xi(fd, family, type_, proto=0):
    '''
    returns socket
    '''
    
    # ---------------------------------------------------------------------------------------------
    # (Step 1/3)
    # ---------------------------------------------------------------------------------------------    

    class2print = "fromfd4xi"
    method2print = "fromfd4xi"
    
    message2print = "{(Step 1/3a) started" + "; fromfd4xi-started: " + str(fromfd4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/3a) passed" + "; fd-passed-to-fromfd4xi: " + str(fd) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/3a) passed" + "; family-passed-to-fromfd4xi: " + str(family) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{(Step 1/3a) passed" + "; type-passed-to-fromfd4xi: " + str(type_) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
               
    message2print = "{(Step 1/3a) passed" + "; proto-passed-to-fromfd4xi: " + str(proto) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
  
    
    # ---------------------------------------------------------------------------------------------
    # (Step 2/3)
    # --------------------------------------------------------------------------------------------- 
          
    message2print = "{(Step 2/3a) passing" + "; fd-passing-to-socket-fromfd-by-fromfd4xi: " + str(fd) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{(Step 2/3b) passing" + "; family-passing-to-socket-fromfd-by-fromfd4xi: " + str(family) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)              
    
    message2print = "{(Step 2/3c) passing" + "; type-passing-to-socket-fromfd-by-fromfd4xi: " + str(type_) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    message2print = "{(Step 2/3d) passing" + "; proto-passing-to-socket-fromfd-by-fromfd4xi: " + str(proto) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
    
    
    try:
    
        # ---------------------------------------------------------------------------------------------
        # 
        # --------------------------------------------------------------------------------------------- 
       
        socket2xi = socket.fromfd(fd, family, type_, proto)
        
        message2print = "{(Step 2/3e) got" + "; socket2xi-got-by-fromfd4xi: " + str(socket2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                        
        message2print = "{(Step 2/3f) checking" + "; socket2xi-class-checking-by-fromfd4xi: " + str(socket2xi.__class__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                   
            
        if socket2xi.__class__ is not socket.socket:
    
            # -----------------------------------------------------------------------------------------
            # 
            # ----------------------------------------------------------------------------------------- 

            socket2xi = socket.socket(_sock=socket2xi)
       
            message2print = "{(Step 2/3g) set" + "; socket2xi-set-by-fromfd4xi to: " + str(socket2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
               
    except:
    
        # ---------------------------------------------------------------------------------------------
        # 
        # --------------------------------------------------------------------------------------------- 
      
        message2print = "{(Step 2/3h) hit" + "; socket-hit-by-fromfd4xi: " + " *** " + str(socket)  + " *** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
    
        socket2xi = None
        
        message2print = "{(Step 2/3i) set" + "; socket2xi-set-by-fromfd4xi to: " + str(socket2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
                
        raise

        
    # -------------------------------------------------------------------------------------------
    # (Step 3/3)
    # --------------------------------------------------------------------------------------------- 
    message2print = "{(Step 3/3) returning" + "; socket2xi-returning-by-fromfd4xi: " + str(socket2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
        
  
    return socket2xi
#</function4xi> 

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fromfd4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
